VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   0  'Kein
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4680
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows-Standard
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.vb-fun.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.
'
'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !

Option Explicit
'=== DirectDraw-Initialisations-Variablen ===
Dim DX7 As New DirectX7
Dim DD7 As DirectDraw7
Dim SurfaceDesc As DDSURFACEDESC2
Dim PrimarySurface As DirectDrawSurface7
Dim BackBuffer As DirectDrawSurface7
Dim ddPF As DDPIXELFORMAT
Dim bmpHintergrund As DirectDrawSurface7
Dim bmpHaus As DirectDrawSurface7
Dim bmpBaum As DirectDrawSurface7
Dim bmpHund As DirectDrawSurface7
Dim SrcColorKey As Integer

Dim running As Boolean


Private Sub Form_Load()
  Dim SrcRect As RECT
  Dim DestRect As RECT
  Dim BGrect As RECT
  
  Me.Show
  Me.Refresh
  
  Initialization   'DirectDraw initialisieren
  BitmapLaden      'Laden der Bitmaps
  
  Hund.X = HundStart
  Hund.Y = 510
  SrcColorKey = 1
  running = True
  
  Do
    FrameTime = GetTime
    
    '--->> Hintergrund
    With SrcRect
      .Left = 0: .Right = 480
      .Top = 0: .Bottom = 320
    End With
    'der Hintergrund soll ber den gesamten Screen gehen
    With BGrect
      .Left = 0: .Right = 800
      .Top = 0: .Bottom = 600
    End With
    'Bitmap in den Backbuffer zeichnen
    BackBuffer.Blt BGrect, bmpHintergrund, SrcRect, DDBLT_WAIT
    
    '--->> Haus
    With SrcRect
      .Left = 0: .Right = 233
      .Top = 0: .Bottom = 235
    End With
    'Bitmap in den BackBuffer zeichnen
    'und dabei die Farbe Magenta ignorieren
    BackBuffer.BltFast _
        567, 280, bmpHaus, SrcRect, DDBLTFAST_WAIT Or SrcColorKey
    
    '--->> Baum
    With SrcRect
      .Left = 0: .Right = 218
      .Top = 0: .Bottom = 196
    End With
    'Bitmap in den BackBuffer zeichnen
    'und dabei die Farbe Weiss ignorieren
    BackBuffer.BltFast _
        200, 330, bmpBaum, SrcRect, DDBLTFAST_WAIT Or SrcColorKey
    BackBuffer.BltFast _
        420, 330, bmpBaum, SrcRect, DDBLTFAST_WAIT Or SrcColorKey
    
    '--->> Hund
    With SrcRect
      .Left = Int(Hund.AniCount) * HundFrameBreite
      .Right = .Left + HundFrameBreite
      .Top = 0: .Bottom = 32
    End With
    Select Case Hund.Status
      Case 0: 'Hund luft bis Mitte des Bildschirms
        DisplaySprite DestRect, bmpHund, SrcRect, Hund.X, Hund.Y
        Hund.X = Hund.X + 2
        Hund.AniCount = Hund.AniCount + 0.2
        If Hund.AniCount >= 4 Then
          If Hund.X > 350 Then
            Hund.Status = 1
            Hund.AniCount = 4
            Hund.PauseCount = 0
          Else
            Hund.AniCount = 0
          End If
        End If
      Case 1: 'Hund bleibt stehen und wedelt mit Schwanz
        DisplaySprite DestRect, bmpHund, SrcRect, Hund.X, Hund.Y
        Hund.AniCount = Hund.AniCount + 0.2
        If Hund.AniCount >= 6 Then Hund.AniCount = 4
        Hund.PauseCount = Hund.PauseCount + 1
        If Hund.PauseCount > HundAniPause Then
          Hund.Status = 2
          Hund.AniCount = 6
          Hund.PauseCount = 0
        End If
      Case 2: 'Hund sitzt
        DisplaySprite DestRect, bmpHund, SrcRect, Hund.X, Hund.Y
        Hund.PauseCount = Hund.PauseCount + 1
        If Hund.PauseCount > HundAniPause Then
          Hund.Status = 3
          Hund.AniCount = 6
          Hund.PauseCount = 0
        End If
      Case 3: 'Hund steht und wedelt mit Schwanz
        DisplaySprite DestRect, bmpHund, SrcRect, Hund.X, Hund.Y
        Hund.AniCount = Hund.AniCount + 0.2
        If Hund.AniCount >= 6 Then Hund.AniCount = 4
        Hund.PauseCount = Hund.PauseCount + 1
        If Hund.PauseCount > HundAniPause Then
          Hund.Status = 4
          Hund.AniCount = 0
          Hund.PauseCount = 0
        End If
      Case 4: 'Hund luft aus Bildschirm
        DisplaySprite DestRect, bmpHund, SrcRect, Hund.X, Hund.Y
        Hund.X = Hund.X + 2
        Hund.AniCount = Hund.AniCount + 0.2
        If Hund.AniCount >= 4 Then
          If Hund.X > 832 Then
            Hund.Status = 5
            Hund.AniCount = 0
            Hund.PauseCount = 0
          Else
            Hund.AniCount = 0
          End If
        End If
      Case 5: 'Hunde-Animation Pause
        Hund.PauseCount = Hund.PauseCount + 1
        If Hund.PauseCount > (HundAniPause * 3) Then
          Hund.Status = 0
          Hund.PauseCount = 0
          Hund.X = HundStart
        End If
    End Select
    
    '--->> Baum
    With SrcRect
      .Left = 0: .Right = 218
      .Top = 0: .Bottom = 196
    End With
    'Bitmap in den BackBuffer zeichnen
    'und dabei die Farbe Weiss ignorieren
    BackBuffer.BltFast _
        55, 360, bmpBaum, SrcRect, DDBLTFAST_WAIT Or SrcColorKey
    
    BackBuffer.SetForeColor vbRed
    BackBuffer.SetFont Me.Font
    BackBuffer.DrawText _
        10, 10, "DirectDraw und transparente Farben", False
    BackBuffer.DrawText _
        10, 30, "<Esc> beendet das Programm", False
    If SrcColorKey = 0 Then
      BackBuffer.DrawText _
          10, 50, "<Space> ColorKey: DDBLTFAST_NOCOLORKEY", False
    Else
      BackBuffer.DrawText _
          10, 50, "<Space> ColorKey: DDBLTFAST_SRCCOLORKEY", False
    End If
    
    'Inhalt des BackBuffers in den PrimarySurface kopieren
    PrimarySurface.Flip Nothing, DDFLIP_WAIT
    
    'BackBuffer lschen
    'da ansonsten alter Speicherinhalt angezeigt wird
    ClearBuffer vbBlack
    
    Do Until GetTime - FrameTime > 18
    Loop
    
    DoEvents
  Loop While running
  
  Terminate
  
End Sub


Private Sub Form_KeyPress(KeyAscii As Integer)
  If (KeyAscii = vbKeyEscape) Then
    running = False
  End If
  If (KeyAscii = vbKeySpace) Then
    If SrcColorKey = 0 Then
      SrcColorKey = 1
    Else
      SrcColorKey = 0
    End If
  End If
End Sub


Sub Initialization()
  
  'Holen wir uns den Zugriff auf das DirectDraw-Objekt.
  'Der leere String-Parameter bedeutet,
  'dass der aktive Bildschirmtreiber benutzt werden soll
  Set DD7 = DX7.DirectDrawCreate("")
  'Die Anwendung soll im VollbildModus laufen
  DD7.SetCooperativeLevel Me.hWnd, DDSCL_EXCLUSIVE Or _
        DDSCL_FULLSCREEN Or DDSCL_ALLOWREBOOT
  'Auflsung und Farbtiefe deklarieren
  DD7.SetDisplayMode 800, 600, 16, 0, DDSDM_DEFAULT
  'Beschreibung des PrimarySurface mit einem BackBuffer
  With SurfaceDesc
    .lFlags = DDSD_CAPS Or DDSD_BACKBUFFERCOUNT
    .ddsCaps.lCaps = DDSCAPS_PRIMARYSURFACE Or _
          DDSCAPS_FLIP Or DDSCAPS_COMPLEX
    .lBackBufferCount = 1
  End With
  'PrimarySurface initialisieren auf dem alles abgebildet wird
  Set PrimarySurface = DD7.CreateSurface(SurfaceDesc)
  
  'Fr die Beschreibung des Backbuffers bentigen wir nur
  'den ddsCaps-Bereich
  SurfaceDesc.ddsCaps.lCaps = DDSCAPS_BACKBUFFER
  'BackBuffer initialisieren in dem alles gezeichnet und dann
  'in die PrimarySurface ge'flipt wird
  Set BackBuffer = _
        PrimarySurface.GetAttachedSurface(SurfaceDesc.ddsCaps)
  
  'aktuelle Farbbitmasken aus der PrimarySurface auslesen
  PrimarySurface.GetPixelFormat ddPF
End Sub

Sub BitmapLaden()
  Dim BmpDesc As DDSURFACEDESC2
  Dim ColorKey As DDCOLORKEY
      
  BmpDesc.lFlags = DDSD_CAPS Or DDSD_HEIGHT Or DDSD_WIDTH
  BmpDesc.ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN
  
  'Hintegrund
  BmpDesc.lWidth = 480
  BmpDesc.lHeight = 320
  Set bmpHintergrund = DD7.CreateSurfaceFromFile _
        (App.Path & "\Hintergrund.bmp", BmpDesc)
  
  'Haus
  BmpDesc.lWidth = 233
  BmpDesc.lHeight = 235
  Set bmpHaus = DD7.CreateSurfaceFromFile _
        (App.Path & "\Haus.bmp", BmpDesc)
  'Im Bild ist die Farbe Magenta RGB(255,0,255)
  'die transparente Farbe
  'daher wird high und low auf Magenta gesetzt
  'lRBitMask und lBBitmask ist Rot und Blau
  'in voller Strke ... daher Magenta
  ColorKey.high = (ddPF.lRBitMask + ddPF.lBBitMask)
  ColorKey.low = (ddPF.lRBitMask + ddPF.lBBitMask)
  'setzen der transparenten Farbe
  bmpHaus.SetColorKey DDCKEY_SRCBLT, ColorKey

  'Baum
  BmpDesc.lWidth = 218
  BmpDesc.lHeight = 196
  Set bmpBaum = DD7.CreateSurfaceFromFile _
        (App.Path & "\Baum.bmp", BmpDesc)
  'im Bild Baum ist Weiss die transparente Farbe
  ColorKey.high = _
        (ddPF.lRBitMask + ddPF.lGBitMask + ddPF.lBBitMask)
  ColorKey.low = _
        (ddPF.lRBitMask + ddPF.lGBitMask + ddPF.lBBitMask)
  bmpBaum.SetColorKey DDCKEY_SRCBLT, ColorKey
  
  'Hund
  BmpDesc.lWidth = 256
  BmpDesc.lHeight = 32
  Set bmpHund = DD7.CreateSurfaceFromFile _
        (App.Path & "\Hund.bmp", BmpDesc)
  'im Bild Hund ist Grn die transparente Farbe
  ColorKey.high = ddPF.lGBitMask
  ColorKey.low = ddPF.lGBitMask
  bmpHund.SetColorKey DDCKEY_SRCBLT, ColorKey
End Sub

Sub ClearBuffer(Color As Long)
  Dim DestRect As RECT
  With DestRect
    .Bottom = 600
    .Left = 0
    .Right = 800
    .Top = 0
  End With
  BackBuffer.BltColorFill DestRect, Color
End Sub

Function GetTime() As Long
  GetTime = DX7.TickCount
End Function

Sub DisplaySprite(DestRect As RECT, Sprite As _
      DirectDrawSurface7, SrcRect As RECT, _
      Optional ByVal xCoord As Long, _
      Optional ByVal yCoord As Long)
  Dim XSrcRect As RECT
  
  XSrcRect = SrcRect
  With SrcRect
    If xCoord > (800 - (.Right - .Left)) Then _
        .Right = (.Right - (xCoord - (800 - (.Right - .Left))))
    If xCoord < 0 Then
      .Left = .Left + (xCoord * -1)
      xCoord = 0
    End If
    If yCoord > (600 - (.Bottom - .Top)) Then _
        .Bottom = (.Bottom - (yCoord - (600 - (.Bottom - .Top))))
    If yCoord < 0 Then
      .Top = .Top + (yCoord * -1)
      yCoord = 0
    End If
  End With
  BackBuffer.BltFast xCoord, yCoord, Sprite, SrcRect, _
        SrcColorKey Or DDBLTFAST_WAIT
  SrcRect = XSrcRect
End Sub

Sub Terminate()
  Set bmpHintergrund = Nothing
  Set bmpHaus = Nothing
  Set bmpBaum = Nothing
  Set bmpHund = Nothing
  'alte Auflsung wiederherstellen
  DD7.RestoreDisplayMode
  DD7.SetCooperativeLevel Me.hWnd, DDSCL_NORMAL
  Set PrimarySurface = Nothing
  Set DD7 = Nothing
  Set DX7 = Nothing
  End
End Sub

